Page MenuHomePhabricator

Create Legalpad for WLM permission form
Closed, ResolvedPublic

Description

As part of Wiki-Loves-Monuments, the WLM international teams collects permissions from the winners to post their photos on social media.

Until now, we have been using an ad-hoc process (through direct e-mail) that does not really scale.

We would like to use Legalpad to do this. The form would cover this edition of Wiki Loves Monuments (ie, if we were to use Legalpad again next year, we would create a new form). Because of the lack of built-in multilingual support in Legalpad, the form would be in English, but with prominent links to a Meta page which would be translated (by local teams).

Event Timeline

JeanFred triaged this task as Medium priority.Oct 15 2018, 4:18 PM
JeanFred created this task.
JeanFred added a subscriber: Aklapper.

@Aklapper Would you be able to provide guidance on the proper process to either have permission to do this, or request to someone who does?

I can create legalpad documents, but I think this is because of my staff role. I'm happy to help create this pad if @Aklapper gives me permission to go ahead.

@Slaporte: Feel very free to go ahead, as I haven't touched Legalpad for a while... Thanks for the help!

Slaporte added a comment.EditedOct 15 2018, 9:24 PM

@Aklapper I spoke too soon -- I tried to create a pad, but got the error:

Only admins may require signature.

Can you create a pad and give me "can edit" capability?

Entertaining, in a bad way:

I went to https://phabricator.wikimedia.org/legalpad/ and clicked "Create Document" and got "You do not have permission to edit this object."
That's because the "Can Create Documents" policy (link for admins) allows members of WMF-Legal, members of #acl*sre-team, Qgil, and Varnent.
The "Default Edit Policy" (link for admins) allows members of WMF-Legal and members of #acl*sre-team.
According to https://phabricator.wikimedia.org/project/members/28/ , @Slaporte is a member of WMF-Legal.

So I have no idea why this does not work for you or what I should change. (Maybe @mmodell has an idea?) I personally more and more think that we either need Legalpad documentation (nothing on https://www.mediawiki.org/wiki/Phabricator/Help ) or should use a different software that is less cumbersome.

@Aklapper perhaps the simplest thing is to give +admin to @Slaporte?

@Slaporte: you are now an admin, would you mind giving it a try one more time?

mmodell added a comment.EditedOct 16 2018, 7:02 PM

I can't even view L36 scratch that, now I can

Dzahn added a comment.Oct 16 2018, 7:03 PM

I think we should first let Stephen try if it works to edit the pad above now. Let's find out why the custom policy works or doesn't work, it says Legal Team should be able to edit. Let's not just fix it by using admin rights?

@Aklapper perhaps the simplest thing is to give +admin to @Slaporte?

@mmodell: That might be the simplest workaround but making everyone an admin who wants to create a Legalpad is not a solution. I'd expect policies that work.

Dzahn added a comment.Oct 16 2018, 7:08 PM

Edited the custom policy of the new pad, L36 to allow "members of legal" and @JeanFred

@JeanFred Is it really going to be just you or more people? I see the use of "we" in your ticket. Who are the other people who should be able to edit it?

The best would be to create a group/project for them, edit the policies to allow that group/project and then add people to it.

@Dzahn Yes, I successfully edited the document. Thank you!

I think the "we" in the ticket is other members of the WLM International Organizing team. I think @JeanFred and I can handle it for now, and we'll look into setting up a group, per your suggestion, if others need to edit.

Dzahn added a comment.Oct 16 2018, 8:04 PM

Cool, sounds good:) I guess we can resolve it here then.

JeanFred updated the task description. (Show Details)Oct 17 2018, 7:54 AM

In the initial discussions with @Effeietsanders and @m.hekmat the form was supposed to be year specific. Shall I rename the form accordingly to WLM 2018, or shall we leave it as is ?

Year specific would allow for updates in the text without changing previous permissions, and would avoid people providing permission for photos that they didn't upload yet (which seems legally dubious). So yeah, I think we should rename :)

Can we make it retroactive? as in the permission applies to all photos submitted up to the time of signing? That way we won't need to ask permission for photos from previous years if the photographer is the same.

Dzahn added a comment.Oct 17 2018, 6:00 PM

I assume you can rename it without needing an admin? If not let me know.

@Dzahn So, turns out I can edit the document, however I can’t save it :) When saving I am prompted with

Only admins may require signature.
JeanFred added a comment.EditedOct 27 2018, 5:35 PM

Note to self: current changes to implement:

JeanFred raised the priority of this task from Medium to High.Oct 29 2018, 5:09 PM

@Dzahn @Aklapper @mmodell Would you be able to solve this permission issue ? Alternatively, would someone be kind enough to implement the above changes for us?

I don't have access to edit the legalpad document and I am an admin.

@JeanFred: Try saving it without "require signature"? as far as I know "require signature" means that the document must be signed by every phabricator user before they can use phabricator. So that's not something we want enabled.

@JeanFred: Try saving it without "require signature"? as far as I know "require signature" means that the document must be signed by every phabricator user before they can use phabricator. So that's not something we want enabled.

There is no such checkbox in the edit form I get.

Dzahn added a subscriber: 20after4.Oct 29 2018, 5:59 PM

I added @20after4 as a subscriber on L36. This should allow you per the custom policy.

I see the legalpad has already been renamed to the new name, so it seems you were able to save it.

Dzahn added a comment.Oct 29 2018, 6:02 PM

Oh sorry, i see the difference is the name didn't have "2018" in it. I just changed that.

Dzahn added a comment.EditedOct 29 2018, 6:09 PM

I can confirm i _do_ see the "Signature required" checkbox that @mmodell refers to but does _not_ show up in @JeanFred's screenshot. But it is not checked by default.

The custom ACL clearly says "Can edit" should be members of legal _and_ JeanFred. It doesn't mention administrators. Something seems like a bug here.

Dzahn added a comment.Oct 29 2018, 6:14 PM

I made all the requested changes except the language bar thing. I can't manage/view source of L32 so i can't just copy/paste it from there and wouldn't be sure about the right meta pages to link to. If you can create the right source , i can paste it.

Separately we should probably keep this open or have another ticket about the ACL weirdness and scaling this.

I still cannot edit L36

I cannot see the list of people who signed. The manage button is still inactive for me.

Dzahn added a comment.EditedOct 29 2018, 6:22 PM

@mmodell @m.hekmat How about now?

Dzahn changed the edit policy from "Custom Policy" to "Custom Policy".

These rules are processed in order:
Allow members of any project: WMF-Legal, User-JeanFred
Allow users: JeanFred, 20after4, m.hekmat, mmodell

I can now manage the document. This thing is exhibiting some really strange behavior.

Yes, now it works. Thanks.

Dzahn added a comment.EditedOct 29 2018, 6:45 PM

Ok, cool. So probably mostly just me using custom policy wrong. "Members of project:" followed by "User-JeanFred" made no sense. I didn't actually mean "members of a project that happens to be his user project" , of course i just meant users. @JeanFred can you also save now?

Ok, cool. So probably mostly just me using custom policy wrong. "Members of project:" followed by "User-JeanFred" made no sense. I didn't actually mean "members of a project that happens to be his user project" , of course i just meant users. @JeanFred can you also save now?

No, I am still getting « Only admins may require signature. »

@JeanFred: Can you try one more time?

JeanFred added a comment.EditedOct 29 2018, 7:05 PM

@JeanFred: Can you try one more time?

Sure. On save:

>>> UNRECOVERABLE FATAL ERROR <<<

Call to a member function getNewValue() on null

/srv/deployment/phabricator/deployment/phabricator/src/applications/transactions/storage/PhabricatorModularTransactionType.php:166

:)

I am no longer able to edit the pad either now. I get:

Unhandled Exception ("RuntimeException")	
Undefined variable: new

Now getting the same as Stephen when saving the pad:

Unhandled Exception ("RuntimeException")

Undefined variable: new

@Slaporte and @JeanFred it should be fixed now

D1123 fixed the check for required signature so that you shouldn't get the bogus "only admins may require signature" error unless you actually check that box and that should be impossible as a non-admin since that box isn't shown.

Dzahn awarded a token.Oct 30 2018, 8:35 PM

Works! Thanks so much for fixing this.

Slaporte closed this task as Resolved.Oct 31 2018, 6:07 AM
Slaporte claimed this task.